loc_3738: ; Game Intro / Title Screen
    move.b  #$FD, d0   
    bsr     PlayMusic          ; loc_14C0
    bsr     ClearPLC        ; loc_179A
    bsr     Pal_FadeFrom        ; loc_263A  
    move    #$2700, SR
    lea     ($C00004), a6
    move.w  #$8004, (a6)
    move.w  #$8230, (a6)
    move.w  #$8407, (a6)
    move.w  #$9001, (a6)
    move.w  #$9200, (a6)
    move.w  #$8B03, (a6)
    move.w  #$8720, (a6)         
    clr.b   (Water_move).w
    move.w  #$8C81, (a6)
    bsr     ClearScreen         ; loc_1418 
    lea     (Sprite_Table_Input).w, a1
    moveq   #0, d0
    move.w  #$FF, d1
TitleScreen2:        
    move.l  d0, (a1)+
    dbra    d1, TitleScreen2
    lea     (Object_RAM).w, a1
    moveq   #0, d0
    move.w  #$7FF, d1
loc_3794:        
    move.l  d0, (a1)+
    dbra    d1, loc_3794
    lea     (Misc_Variables).w, a1
    moveq   #0, d0
    move.w  #$3F, d1
loc_37A4:        
    move.l  d0, (a1)+
    dbra    d1, loc_37A4
    lea     (Camera_RAM).w, a1
    moveq   #0, d0
    move.w  #$3F, d1
loc_37B4:        
    move.l  d0, (a1)+
    dbra    d1, loc_37B4
    lea     (Second_palette).w, a1
    moveq   #0, d0
    move.w  #$1F, d1
loc_37C4:        
    move.l  d0, (a1)+
    dbra    d1, loc_37C4
    moveq   #3, d0        ; Load Sonic Palette "Sonic Team Presents" Left Over
    bsr     PalLoad1        ; loc_28E2
    bsr     Pal_FadeTo          ; loc_2596
    move    #$2700, SR
    move.l  #$40000000, ($C00004)
    lea     (Title_Screen_Bg_Wings), A0 ; loc_71520 ; Load Title Screen wings and background
    bsr     NemesisDec          ; loc_15FC
    move.l  #$40000001, ($C00004)
    lea     (Title_Screen_Sonic_Tails), A0 ; loc_72E82 ; Load Sonic and Tails in Title Screen
    bsr     NemesisDec          ; loc_15FC
    lea     ($C00000), a6
    move.l  #$50000003, mappings(a6)
    lea     (Art_Menu_Text), a5     ; loc_5E8
    move.w  #$28F, d1
loc_3818:
    move.w  (a5)+, (a6)
    dbra    d1, loc_3818
    nop
    move.b  #0, (Last_star_pole_hit).w
    move.w  #$00, (Debug_placement_mode).w
    move.w  #$00, (Demo_mode_flag).w
    move.w  #$00, ($FFFFFFDA).w
    move.w  #$F00, (Current_ZoneAndAct).w
    move.w  #$00, ($FFFFF634).w
    bsr     Pal_FadeFrom        ; loc_263A 
    move    #$2700, SR
    lea     (Metablock_Table), a1
    lea     (TS_Wings_Sonic_Mappings), A0 ; loc_70ECC Load Wings, Sonic 2, (c) Sega 1992 mappings
    move.w  #$00, d0
    bsr     EnigmaDec           ; loc_18DA
    lea     (Metablock_Table), a1
    move.l  #$40000003, d0
    moveq   #$27, d1
    moveq   #$1B, d2
    bsr     ShowVDPGraphics     ; loc_154C
    lea     (Metablock_Table), a1
    lea     (Title_Screen_Bg_Mappings), A0 ; loc_71024 Load Title Screen Background mappings
    move.w  #$00, d0
    bsr     EnigmaDec           ; loc_18DA
    lea     (Metablock_Table), a1
    move.l  #$60000003, d0
    moveq   #$1F, d1
    moveq   #$1B, d2
    bsr     ShowVDPGraphics     ; loc_154C
    lea     (Metablock_Table), a1
    lea     (Title_Screen_R_Bg_Mappings), A0 ; loc_712D8 Load Title Screen Background mappings (Right Side) 
    move.w  #$00, d0
    bsr     EnigmaDec           ; loc_18DA
    lea     (Metablock_Table), a1
    move.l  #$60400003, d0
    moveq   #$1F, d1
    moveq   #$1B, d2
    bsr     ShowVDPGraphics     ; loc_154C
    moveq   #1, d0        ; Load Title Screen Palette
    bsr     PalLoad1        ; loc_28E2      
    move.b  #$99, d0        ; Load Title Screen Music
    bsr     PlayMusic          ; loc_14C0
    move.b  #0, (Debug_mode_flag).w
    move.w  #$00, (Two_player_mode).w
    move.w  #$178, (Demo_Time_left).w
    lea     ($FFFFB080).w, a1
    moveq   #0, d0
    move.w  #$F, d1
loc_38EE:        
    move.l  d0, (a1)+
    dbra    d1, loc_38EE   
        
    move.b  #$E, (Sidekick).w
    move.b  #$E, ($FFFFB080).w
    move.b  #1, ($FFFFB09A).w
    jsr     (Load_Objects)      ; loc_CFD0
    jsr     (Build_Sprites)     ; loc_D4DA
    moveq   #0, d0
    bsr     LoadPLC2        ; loc_176E
    move.w  #$00, (Correct_cheat_entries).w
    move.w  #$00, (Correct_cheat_entries_2).w
    move.b  #1, (Level_select_flag).w
    move.w  #$4, (Sonic_Pos_Record_Index).w
    move.w  #$00, (Sonic_Pos_Record_Buf).w
    move.w  (VDP_Reg0_Val).w, d0
    ori.b   #$40, d0
    move.w  d0, ($C00004)
    bsr     Pal_FadeTo          ; loc_2596
TitleScreen_Loop: ; loc_3948:        
    move.b  #4, (Delay_Time).w
    bsr     DelayProgram        ; loc_31D8
    jsr     (Load_Objects)      ; loc_CFD0
    bsr     loc_5E38     ; Load Title Screen Background Scroll 
    jsr     (Build_Sprites)     ; loc_D4DA
    bsr     RunPLC          ; loc_17A8
    tst.b   (Graphics_Flags).w
    bpl.s   Code_Sequence_J     ; loc_3974
    lea     (Level_Select_Code_J), A0 ; loc_3B5A
    bra.s   Level_Select_Cheat_Test ; loc_397A
Code_Sequence_J: ; loc_3974:
    lea     (Level_Select_Code_US), A0 ; loc_3B52
Level_Select_Cheat_Test: ;  loc_397A:        
    move.w  (Correct_cheat_entries).w, d0
    adda.w  d0, A0
    move.b  (Ctrl_1_Press).w, d0
    andi.b  #$F, d0
    cmp.b   (A0), d0
    bne.s   Title_Cheat_NoMatch     ; loc_39C0
    addq.w  #1, (Correct_cheat_entries).w
    tst.b   d0
    bne.s   Title_Cheat_CountC      ; loc_39D2
    lea     (Level_select_flag).w, A0
    move.w  (Correct_cheat_entries_2).w, d1
    lsr.w   #1, d1
    andi.w  #$3, d1
    beq.s   Title_Cheat_PlayRing    ; loc_39B0
    tst.b   (Graphics_Flags).w
    bpl.s   Title_Cheat_PlayRing    ; loc_39B0
    moveq   #1, d1
    move.b  d1, $1(A0, d1)           
Title_Cheat_PlayRing: ; loc_39B0:
    move.b  #1, $00(A0, d1)
    move.b  #$B5, d0
    bsr     Play_Sfx        ; loc_14C6
    bra.s   Title_Cheat_CountC      ; loc_39D2
Title_Cheat_NoMatch: ; loc_39C0:        
    tst.b   d0
    beq.s   Title_Cheat_CountC      ; loc_39D2
    cmpi.w  #$9, (Correct_cheat_entries).w
    beq.s   Title_Cheat_CountC      ; loc_39D2
    move.w  #$00, (Correct_cheat_entries).w
Title_Cheat_CountC: ; loc_39D2:
    move.b  (Ctrl_1_Press).w, d0
    andi.b  #$20, d0
    beq.s   Title_Cheat_NoC     ; loc_39E0
    addq.w  #1, (Correct_cheat_entries_2).w
Title_Cheat_NoC: ; loc_39E0:
    tst.w   (Demo_Time_left).w
    beq     Demo_Mode           ; loc_3B62
    andi.b  #$80, (Ctrl_1_Press).w
    beq     TitleScreen_Loop    ; loc_3948
EnterLevelSelect:        
    tst.b   (Level_select_flag).w
    beq     PlayLevel           ; loc_3B12
    btst    #6, (Ctrl_1_Held).w
    beq     PlayLevel           ; loc_3B12
    move.b  #$8A, d0        ; Load Level Select Menu Music
    bsr     PlayMusic          ; loc_14C0
    moveq   #2, d0
    bsr     PalLoad2        ; loc_28FE
    lea     (Horiz_Scroll_Buf).w, a1
    moveq   #0, d0
    move.w  #$DF, d1	