loc_85F8:			;Object 15
        btst    #6,render_flags(a0)
        bne     Obj15_BeginDis
        moveq	#0,d0
        move.b  routine(a0),d0
        move.w  Obj15_States(pc,d0), d1
        jmp     Obj15_States(pc,d1)
; ---------------------------------------------------------------------------		
Obj15_BeginDis:
        move.w  #$200, d0
        bra     DisplaySprite_Param     ; loc_D3FE
; ===========================================================================		
Obj15_States:
        dc.w    Obj15_Init-Obj15_States
        dc.w    Obj15_State2-Obj15_States
        dc.w    Obj15_Display-Obj15_States
        dc.w    Obj15_State4-Obj15_States
        dc.w    Obj15_State5-Obj15_States
        dc.w    Obj15_State6-Obj15_States
        dc.w    Obj15_State7-Obj15_States
; ===========================================================================		
Obj15_Init:
        addq.b  #2,routine(a0)
        move.l  #Swing_Platforms_Mappings,mappings(a0) ; loc_8AD8
        move.w  #$43E3,art_tile(a0) ; standard plc load address
        move.b  #4,render_flags(a0)
        move.b  #3,priority(a0)
        move.b  #$20,width_pixels(a0) 
        move.b  #$10, y_radius(a0)
        move.w  y_pos(a0), objoff_38(a0)
        move.w  x_pos(a0), objoff_3A(a0)
        cmpi.b  #$B, (Current_ZoneAndAct).w ; is level Mystic Cave Zone?
        bne.s   Obj15_NGHZ ; if not, move on to Aquatic Ruins loading
        move.l  #DhzPlatformsMappings,mappings(a0) ; loc_8B46 
        move.w  #0,art_tile(a0)    ; MCZ plc load address           
        move.b  #$18,width_pixels(a0)
        move.b  #8, y_radius(a0)
		
Obj15_NGHZ:
        cmpi.b  #$F, (Current_ZoneAndAct).w ;is Level Aquatic Ruin?
        bne.s   Obj15_NGHZArtLoad
        move.l  #Nghz_Swing_Platforms_Mappings,mappings(a0) ; loc_8B0E
        move.w  #0,art_tile(a0)
        move.b  #$20,width_pixels(a0)
        move.b  #8, y_radius(a0)
		
Obj15_NGHZArtLoad:
        bsr     Adjust2PArtPointer     ; loc_DC30
        moveq   #0,d1
        move.b  subtype(A0), d1
        bpl.s   Obj15_Load
        addq.b  #4,routine(a0)
		
Obj15_Load:
        andi.w  #$F, d1
        move.w  d1, D2
        lsl.w   #4, D2
        addi.b  #8, D2
        move.b  D2, Objoff_3C(a0)
        move.w  x_pos(a0), D2
        move.w  y_pos(a0), D3
        bsr     JmpTo_SingleObjLoad2      ; loc_E788
        bne.s   Obj15_DHZSets
        move.b  0(A0), 0(a1) ; load obj15
        move.l  mappings(A0), mappings(a1)
        move.w  art_tile(A0), art_tile(a1)
        move.b  #4, render_flags(a1)
        bset    #6, render_flags(a1)
        move.b  #$48, Objoff_E(a1)
        move.b  d1, Objoff_F(a1)
        subq.b  #1,d1
        lea     $10(a1),a2
		
loc_86FC:        
        move.w  D2, (A2)+
        move.w  d3, (A2)+
        move.w  #$001, (A2)+
        addi.w  #$010, d3
        dbra    d1, loc_86FC
        move.b  #$2, $0015(a1)
        move.w  D2, x_pos(a1)
        move.w  d3, y_pos(a1)
        move.b  #1, $000B(a1)
        move.l  A1, Objoff_30(a0)
        addi.w  #8, d3
        move.w  d3, y_pos(a0)
        move.b  #$50, $14(a1)
        bset    #4, render_flags(a1)
		
Obj15_DHZSets:
        move.w  #$8000,angle(a0)
        move.w  #0, Objoff_3E(a0)
        move.b  subtype(A0), d1
        andi.w  #$70, d1
        move.b  d1, subtype(a0)
        cmpi.b  #$40, d1
        bne.s   Obj15_State2
        move.l  #DhzPlatformsMappings2,mappings(a0) ; loc_8B7A
        move.b  #$A7,collision_flags(a0)
Obj15_State2:
        move.w  x_pos(a0), -(A7)
        bsr     loc_8784
        moveq   #0,d1
        move.b width_pixels(a0), d1
        moveq   #0, d3
        move.b  y_radius(A0), D3
        addq.b  #1, d3
        move.w  (A7)+, D4
        bsr     loc_FA28
        bra     loc_88FC
		
loc_8784:
        move.b  ($FFFFFE78).w, d0
        move.b  subtype(A0), d1
        beq.s   loc_87C4
        cmpi.b  #$10, d1
        bne.s   loc_879E
        cmpi.b  #$40, d0
        bcc.s   loc_87C4
        moveq   #$40, d0
        bra.s   loc_87C4
; ===========================================================================
		
loc_879E:
        cmpi.b  #$20, d1
        bne.s   loc_87AA
        moveq   #$40, d0
        bra     loc_885C
loc_87AA:
        cmpi.b  #$30, d1
        bne.s   loc_87BA
        cmpi.b  #$40, d0
        bcs.s   loc_87C4
        moveq   #$40, d0
        bra.s   loc_87C4
loc_87BA:
        cmpi.b  #$40, d1
        bne.s   loc_87C4
        bsr     loc_885E
loc_87C4:
        move.w  #$080, d1
        btst    #0, status(a0)
        beq.s   loc_87D4
        neg.w   D0
        add.w   d1, d0
loc_87D4:
        bsr     CalcSine        ; loc_320A
        move.w  objoff_38(A0), D2
        move.w  objoff_3A(A0), D3
        moveq   #0, D4
        move.b  Objoff_3C(a0), D4
        move.l  d4,d5
        muls.w  d0, D4
        asr.l   #8, D4
        muls.w  d1,d5
        asr.l   #8,d5
        add.w   D2, D4
        add.w   d3,d5
        move.w  d4, y_pos(a0)
        move.w  d5, x_pos(a0)
        moveq   #0, D6
        move.l  Objoff_30(A0), A1
        move.b  Objoff_F(A1), D6
        subq.w  #1, D6
        bcs.s   loc_885C
        asl.w   #4, d0
        ext.l   D0
        asl.l   #8,d0
        asl.w   #4, d1
        ext.l   d1
        asl.l   #8, d1
        moveq   #0, D4
        moveq   #0,d5
        lea     $10(a1),a2
loc_881E:        
        movem.l D4/d5, -(A7)
        swap.w  D4
        swap.w  D5
        add.w   D2, D4
        add.w   d3,d5
        move.w  d5, (A2)+
        move.w  d4, (A2)+
        movem.l (A7)+, D4/D5
        add.l   d0, D4
        add.l   d1,d5
        addq.w  #$2, a2
        dbra    d6, loc_881E
        swap.w  D4
        swap.w  D5
        add.w   D2, D4
        add.w   d3,d5
        move.w  subtype(A1), D0
        move.w  $002A(A1), d1
        move.w  d5, subtype(a1)
        move.w  d4, $002A(a1)
        move.w  d0, x_pos(a1)
        move.w  d1, y_pos(a1)
loc_885C:
        rts
loc_885E:
        tst.w   objoff_36(a0)
        beq.s   loc_886C
        subq.w  #1, objoff_36(a0)
        bra     loc_88F6
loc_886C:
        tst.b   Objoff_34(a0)
        bne.s   loc_8892
        move.w  (MainCharacter+x_pos).w, d0
        sub.w   objoff_3A(A0), D0
        addi.w  #$20, d0
        cmpi.w  #$40, d0
        bcc.s   loc_88F6
        tst.w   (Debug_placement_mode).w
        bne     loc_88F6
        move.b  #1, Objoff_34(a0)
loc_8892:
        tst.b   objoff_3D(a0)
        beq.s   loc_88C8
        move.w  Objoff_3E(A0), D0
        addi.w  #8, d0
        move.w  d0, Objoff_3E(a0)
        add.w   d0,angle(a0)
        cmpi.w  #$200, d0
        bne.s   loc_88F6
        move.w  #0, Objoff_3E(a0)
        move.w  #$8000,angle(a0)
        move.b  #0, objoff_3D(a0)
        move.w  #$03C, objoff_36(a0)
        bra.s   loc_88F6
; ===========================================================================
		
loc_88C8:
        move.w  Objoff_3E(A0), D0
        subi.w  #8, d0
        move.w  d0, Objoff_3E(a0)
        add.w   d0,angle(a0)
        cmpi.w  #$FE00, d0
        bne.s   loc_88F6
        move.w  #0, Objoff_3E(a0)
        move.w  #$4000,angle(a0)
        move.b  #1, objoff_3D(a0)
        move.w  #$03C, objoff_36(a0)
loc_88F6:
        move.b  angle(A0), D0
        rts
; ===========================================================================
		
loc_88FC:
        tst.w   (Two_player_mode).w
        beq.s   loc_8906
        bra     DisplaySprite           ; loc_D3C2
; ===========================================================================
		
loc_8906:
        move.w  objoff_3A(A0), D0
        andi.w  #$FF80, d0
        sub.w   (Camera_X_pos_coarse).w, d0
        cmpi.w  #$280, d0
        bhi     loc_891E
        bra     DisplaySprite           ; loc_D3C2
; ===========================================================================
		
loc_891E:
        move.l  Objoff_30(A0), A1
        bsr     DeleteObject2
        bra     DeleteObject            ; loc_D3B4
; ===========================================================================
		
Obj15_Display:
        bra     DisplaySprite           ; loc_D3C2
; ===========================================================================
		
Obj15_State4:
        move.w  x_pos(a0), -(A7)
        bsr     loc_8784
        moveq   #0,d1
        move.b width_pixels(a0), d1
        moveq   #0, d3
        move.b  y_radius(A0), D3
        addq.b  #1, d3
        move.w  (A7)+, D4
        bsr     loc_FA28
        move.b  status(a0), D0
        andi.b  #$18, d0
        beq     loc_89E4
        tst.b   ($FFFFFE78).w
        bne     loc_89E4
        bsr     JmpTo_SingleObjLoad2      ; loc_E788
        bne.s   loc_89D4
        moveq	#0,d0
        move.w  #$F, d1
		
loc_896A:        
        move.l  $00(A0, d0), $00(A1, d0)
        addq.w  #4, d0
        dbra    d1, loc_896A
        move.b  #$A, $0024(a1)
        cmpi.b  #$F, (Current_ZoneAndAct).w
        bne.s   loc_8988
        addq.b  #$2, $0024(a1)
loc_8988:
        move.w  #$200,x_vel(a1)
        btst    #0, status(a0)
        beq.s   loc_899A
        neg.w  x_vel(a1)
		
loc_899A:
        bset    #1, status(a1)
        move.w  A0, d0
        subi.w  #Object_RAM, d0
        lsr.w   #6, d0
        andi.w  #$07F, d0
        move.w  A1, d1
        subi.w  #Object_RAM, d1
        lsr.w   #6, d1
        andi.w  #$07F, d1
        lea     (MainCharacter).w, A1
        cmp.b   objoff_3D(A1), D0
        bne.s   loc_89C6
        move.b  d1, objoff_3D(a1)
loc_89C6:
        lea     (Sidekick).w, A1
        cmp.b   objoff_3D(A1), D0
        bne.s   loc_89D4
        move.b  d1, objoff_3D(a1)
loc_89D4:
        move.b  #3, $001A(a0)
        addq.b  #2,routine(a0)
        andi.b  #$E7, status(a0)
loc_89E4:
        bra     loc_88FC
Obj15_State5:
        bsr     loc_8784
        bra     loc_88FC
Obj15_State6:
        move.w  x_pos(a0), -(A7)
        btst    #1, status(a0)
        beq.s   loc_8A2E
        bsr     SpeedToPos              ; loc_D27A
        addi.w  #$018, $0012(a0)
        cmpi.w  #$720, y_pos(a0)
        bcs.s   loc_8A3E
        move.w  #$720, y_pos(a0)
        bclr    #1, status(a0)
        move.w  #0,x_vel(a0)
        move.w  #0, $0012(a0)
        move.w  y_pos(a0), objoff_38(a0)
        bra.s   loc_8A3E
loc_8A2E:
        moveq	#0,d0
        move.b  ($FFFFFE74).w, d0
        lsr.w   #1,d0
        add.w   objoff_38(A0), D0
        move.w  d0, y_pos(a0)
loc_8A3E:
        moveq   #0,d1
        move.b width_pixels(a0), d1
        moveq   #0, d3
        move.b  y_radius(A0), D3
        addq.b  #1, d3
        move.w  (A7)+, D4
        bsr     loc_FA28
        bra     MarkObjGone             ; loc_D2A0
Obj15_State7:
        move.w  x_pos(a0), -(A7)
        bsr     SpeedToPos              ; loc_D27A
        btst    #1, status(a0)
        beq.s   loc_8A92
        addi.w  #$018, $0012(a0)
        move.w  (Water_Level_2).w, d0
        cmp.w   y_pos(a0), D0
        bhi.s   loc_8AC0
        move.w  d0, y_pos(a0)
        move.w  d0, objoff_38(a0)
        bclr    #1, status(a0)
        move.w  #$100,x_vel(a0)
        move.w  #0, $0012(a0)
        bra.s   loc_8AC0
loc_8A92:
        moveq	#0,d0
        move.b  ($FFFFFE74).w, d0
        lsr.w   #1,d0
        add.w   objoff_38(A0), D0
        move.w  d0, y_pos(a0)
        tst.w  x_vel(a0)
        beq.s   loc_8AC0
        moveq   #0, d3
        move.b width_pixels(a0), D3
        bsr     loc_8B94
        tst.w   d1
        bpl.s   loc_8AC0
        add.w   d1, x_pos(a0)
        move.w  #0,x_vel(a0)
loc_8AC0:
        moveq   #0,d1
        move.b  width_pixels(a0), d1
        moveq   #0, d3
        move.b  y_radius(A0), D3
        addq.b  #1, d3
        move.w  (A7)+, D4
        bsr     loc_FA28
        bra     MarkObjGone             ; loc_D2A0
		
;===============================================================================   		
Swing_Platforms_Mappings: ; loc_8AD8:
       incbin "mappings/main/Obj15main.bin"   

;===============================================================================   	   
Nghz_Swing_Platforms_Mappings: ; loc_8B0E:
       incbin "mappings/NGHZ/Obj15.bin"   

;===============================================================================   	   
DhzPlatformsMappings: ; loc_8B46:
       incbin "mappings/DHZ/Obj15.bin"  
	   
;===============================================================================   
DhzPlatformsMappings2: ;loc_8B7A:	   
       incbin "mappings/DHZ/Obj15p2.bin" 
	   
;===============================================================================   	   