loc_CD7C:
    moveq   #0, d0
    move.b  routine(A0), d0
    move.w  loc_CD8E(pc, d0), d1
    jsr     loc_CD8E(pc, d1)
    bra     MarkObjGone         ; loc_D2A0
loc_CD8E:
    dc.w    loc_CD94-loc_CD8E
    dc.w    loc_CDC2-loc_CD8E
    dc.w    loc_CE3A-loc_CD8E
loc_CD94:
    addq.b  #2, routine(A0)
    move.l  #loc_CF04, mappings(A0)
    move.w  #$4590, $2(A0)
    bsr     Adjust2PArtPointer     ; loc_DC30
    move.b  #4, $1(A0)
    move.b  #$10, width_pixels(A0)
    move.b  #4, priority(A0)
    move.b  subtype(A0), mapping_frame(A0)
loc_CDC2:
    move.w  ($FFFFB010).w, $30(A0)
    move.w  #$1B, d1
    move.w  #$20, d2
    move.w  #$20, d3
    move.w  x_pos(A0), d4
    bsr     SolidObject         ; loc_F4A0
    btst    #5, status(A0)
    bne.s   loc_CDE6
loc_CDE4:        
    rts
loc_CDE6:
    lea     (MainCharacter).w, a1
    cmpi.b  #2, anim(a1)
    bne.s   loc_CDE4
    move.w  $30(A0), d0
    bpl.s   loc_CDFA
    neg.w   d0
loc_CDFA:
    cmpi.w  #$480, d0
    bcs.s   loc_CDE4
    move.w  $30(A0), x_vel(a1)
    addq.w  #4, x_pos(a1)
    lea     (loc_CEC4), a4
    move.w  x_pos(A0), d0
    cmp.w   x_pos(a1), d0
    bcs.s   loc_CE26
    subi.w  #$8, x_pos(a1)
    lea     (loc_CEE4), a4
loc_CE26:
    move.w  x_vel(a1), inertia(a1)
    bclr    #5, status(A0)
    bclr    #5, status(a1)
    bsr.s   loc_CE50
loc_CE3A:
    bsr     SpeedToPos          ; loc_D27A
    addi.w  #$70, y_vel(A0)
    tst.b   $1(A0)
    bpl     DeleteObject        ; loc_D3B4
    bra     DisplaySprite       ; loc_D3C2
;=============================================================================== 
; Object 0x3C 
; [ End ]             
;=============================================================================== 

loc_CE50:
    moveq   #0, d0
    move.b  mapping_frame(A0), d0
    add.w   d0, d0
    move.l  mappings(A0), a3
    adda.w  $00(a3, d0), a3
    move.w  (a3)+, d1
    subq.w  #1, d1
    bset    #5, $1(A0)
    move.b  $0000(A0), d4
    move.b  $1(A0), d5
    move.l  A0, a1
    bra.s   loc_CE7E
loc_CE76:        
    bsr     JmpTo_SingleObjLoad2      ; loc_E788
    bne.s   loc_CEBA
    addq.w  #8, a3
loc_CE7E:
    move.b  #4, routine(a1)
    move.b  d4, $0000(a1)
    move.l  a3, mappings(a1)
    move.b  d5, $1(a1)
    move.w  x_pos(A0), x_pos(a1)
    move.w  y_pos(A0), y_pos(a1)
    move.w  $2(A0), $2(a1)
    move.b  priority(A0), priority(a1)
    move.b  width_pixels(A0), width_pixels(a1)
    move.w  (a4)+, x_vel(a1)
    move.w  (a4)+, y_vel(a1)
    dbra    d1, loc_CE76
loc_CEBA:
    move.w  #$CB, d0
    jmp     (Play_Sfx)          ; loc_14C6
loc_CEC4:
    dc.w    $400, $FB00, $600, $FF00, $600, $100, $400, $500
    dc.w    $600, $FA00, $800, $FE00, $800, $200, $600, $600        
loc_CEE4:
    dc.w    $FA00, $FA00, $F800, $FE00, $F800, $200, $FA00, $600
    dc.w    $FC00, $FB00, $FA00, $FF00, $FA00, $100, $FC00, $500           
loc_CF04:
    dc.w    loc_CF0A-loc_CF04
    dc.w    loc_CF4C-loc_CF04
    dc.w    loc_CF8E-loc_CF04
loc_CF0A:
    dc.w    $8
    dc.l    $E0050000, $0000FFF0, $F0050000, $0000FFF0
    dc.l    $50000, $0000FFF0, $10050000, $0000FFF0
    dc.l    $E0050004, $20000, $F0050004, $20000
    dc.l    $50004, $20000, $10050004, $20000
loc_CF4C:
    dc.w    $8
    dc.l    $E0050004, $2FFF0, $F0050004, $2FFF0
    dc.l    $50004, $2FFF0, $10050004, $2FFF0
    dc.l    $E0050004, $20000, $F0050004, $20000
    dc.l    $50004, $20000, $10050004, $20000
loc_CF8E:
    dc.w    $8
    dc.l    $E0050004, $2FFF0, $F0050004, $2FFF0
    dc.l    $50004, $2FFF0, $10050004, $2FFF0
    dc.l    $E0050008, $40000, $F0050008, $40000
    dc.l    $50008, $40000, $10050008, $40000