loc_10E38:         
    moveq   #0, d0
    move.b  routine(A0), d0
    move.w  Tails_Index(pc, d0), d1      ; loc_10E46
    jmp     Tails_Index(pc, d1)      ; loc_10E46
Tails_Index: ; loc_10E46:
    dc.w    Tails_Main-Tails_Index       ; loc_10E50
    dc.w    Tails_Control-Tails_Index    ; loc_10EB4
    dc.w    Tails_Hurt-Tails_Index       ; loc_11AC4
    dc.w    Tails_Death-Tails_Index      ; loc_11B32
    dc.w    Tails_ResetLevel-Tails_Index ; loc_11B8E
Tails_Main: ; loc_10E50:
    addq.b  #2, routine(A0)
    move.b  #$F, y_radius(A0)
    move.b  #$9, x_radius(A0)
    move.l  #Tails_Mappings, mappings(A0) ; loc_6FB3C
    move.w  #$7A0, $2(A0)
    bsr     Adjust2PArtPointer     ; loc_DC30
    move.b  #2, priority(A0)
    move.b  #$18, width_pixels(A0)
    move.b  #$84, $1(A0)
    move.w  #$600, (Sonic_top_speed).w
    move.w  #$C, (Sonic_acceleration).w
    move.w  #$80, (Sonic_deceleration).w
    move.b  #$C, $3E(A0)
    move.b  #$D, $3F(A0)
    move.b  #0, $2C(A0)
    move.b  #4, $2D(A0)
    move.b  #5, ($FFFFB1C0).w
Tails_Control: ; loc_10EB4:
    bsr     Tails_Control2      ; loc_10F96
    btst    #0, $2A(A0)
    bne.s   Tails_ControlsLock      ; loc_10ED2
    moveq   #0, d0
    move.b  status(A0), d0
    andi.w  #$6, d0
    move.w  Tails_Modes(pc, d0), d1 ; loc_10EFA
    jsr     Tails_Modes(pc, d1)     ; loc_10EFA
Tails_ControlsLock: ; loc_10ED2:
    bsr.s   Tails_Display       ; loc_10F12
    bsr     Tails_RecordMoves       ; loc_11056
    move.b  ($FFFFF768).w, $36(A0)
    move.b  ($FFFFF76A).w, $37(A0)
    bsr     Tails_Animate       ; loc_11BA2
    tst.b   $2A(A0)
    bmi.s   loc_10EF4
    jsr     TouchResponse       ; loc_21160
loc_10EF4:
    bsr     Load_Tails_Dynamic_PLC  ; loc_11F42
    rts
Tails_Modes: ; loc_10EFA:
    dc.w    Tails_MdNormal-Tails_Modes  ; loc_11070
    dc.w    Tails_MdJump-Tails_Modes    ; loc_11098
    dc.w    Tails_MdRoll-Tails_Modes    ; loc_110C2
    dc.w    Tails_MdJump2-Tails_Modes   ; loc_110E2
Tails_PlayList: ; loc_10F02:
    dc.b    $82, $82, $83, $90, $83, $83, $93, $96, $86, $8F, $81, $85, $84, $8D, $8D, $87 

;=============================================================================== 
; Sub Routine Tails_Display
; [ Begin ]             
;===============================================================================                  
Tails_Display: ; loc_10F12:
    move.w  $30(A0), d0
    beq.s   loc_10F20
    subq.w  #1, $30(A0)
    lsr.w   #3, d0
    bcc.s   loc_10F26
loc_10F20:
    jsr     DisplaySprite       ; loc_D3C2
loc_10F26:
    tst.b   ($FFFFFE2D).w
    beq.s   loc_10F60
    tst.w   $32(A0)
    beq.s   loc_10F60
    subq.w  #1, $32(A0)
    bne.s   loc_10F60
    tst.b   (Current_Boss_ID).w
    bne.s   loc_10F5A
    cmpi.w  #$C, ($FFFFFE14).w
    bcs.s   loc_10F5A
    moveq   #0, d0
    move.b  (Current_Zone).w, d0
    lea     Tails_PlayList(pc), a1  ; loc_10F02
    move.b  $00(a1, d0), d0
    jsr     (PlayMusic)        ; loc_14C0
loc_10F5A:
    move.b  #0, ($FFFFFE2D).w
loc_10F60:
    tst.b   ($FFFFFE2E).w
    beq.s   loc_10F94
    tst.w   $34(A0)
    beq.s   loc_10F94
    subq.w  #1, $34(A0)
    bne.s   loc_10F94
    move.w  #$600, (Sonic_top_speed).w
    move.w  #$C, (Sonic_acceleration).w
    move.w  #$80, (Sonic_deceleration).w
    move.b  #0, ($FFFFFE2E).w
    move.w  #$FC, d0
    jmp     (PlayMusic)        ; loc_14C0
loc_10F94:
    rts  
;=============================================================================== 
; Sub Routine Tails_Display
; [ End ]             
;===============================================================================   

;=============================================================================== 
; Sub Routine Tails_Control2
; [ Begin ]             
;===============================================================================     
Tails_Control2: ; loc_10F96:
    move.b  (Ctrl_2).w, d0
    andi.b  #$7F, d0
    beq.s   Tails_ControlNoKeysPressed    ; loc_10FAE
    move.w  #$00, (Misc_Variables).w
    move.w  #$12C, (Tails_control_counter).w
    rts
Tails_ControlNoKeysPressed: ; loc_10FAE:
    tst.w   (Tails_control_counter).w
    beq.s   Tails_DoControl    ; loc_10FBA
    subq.w  #1, (Tails_control_counter).w
    rts
Tails_DoControl: ; loc_10FBA:
    move.w  (Tails_CPU_routine).w, d0
    move.w  Tails_ControlIndex(pc, d0), d0 ; loc_10FC6
    jmp     Tails_ControlIndex(pc, d0)     ; loc_10FC6
Tails_ControlIndex: ; loc_10FC6:
    dc.w    Tails_Control_00-Tails_ControlIndex  ; loc_10FCE
    dc.w    Tails_Control_01-Tails_ControlIndex  ; loc_10FD6
    dc.w    Tails_Control_02-Tails_ControlIndex  ; loc_10FEA
    dc.w    Tails_ControlCopySonicMoves-Tails_ControlIndex ; loc_11024
Tails_Control_00: ; loc_10FCE:
    move.w  #$6, (Tails_CPU_routine).w
    rts
Tails_Control_01: ; loc_10FD6:
    move.w  #$6, (Tails_CPU_routine).w
    rts
    move.w  #$40, ($FFFFF706).w
    move.w  #$4, (Tails_CPU_routine).w
Tails_Control_02: ; loc_10FEA:
    move.w  #$6, (Tails_CPU_routine).w
    rts
    move.w  ($FFFFF706).w, d1
    subq.w  #1, d1
    cmpi.w  #$10, d1
    bne.s   loc_11004
    move.w  #$6, (Tails_CPU_routine).w
loc_11004:
    move.w  d1, ($FFFFF706).w
    lea     (Tails_Pos_Record_Buf).w, a1
    lsl.b   #2, d1
    addq.b  #4, d1
    move.w  ($FFFFEEE0).w, d0
    sub.b   d1, d0
    move.w  $00(a1, d0), x_pos(A0)
    move.w  $2(a1, d0), y_pos(A0)
    rts
Tails_ControlCopySonicMoves: ; loc_11024:
    move.w  ($FFFFB008).w, d0
    sub.w   x_pos(A0), d0
    bpl.s   loc_11030
    neg.w   d0
loc_11030:
    cmpi.w  #$C0, d0
    bcs.s   loc_11038
    nop
loc_11038:
    lea     (Sonic_Pos_Record_Buf).w, a1
    move.w  #$10, d1
    lsl.b   #2, d1
    addq.b  #4, d1
    move.w  (Sonic_Pos_Record_Index).w, d0
    sub.b   d1, d0
    lea     (Sonic_Stat_Record_Buf).w, a1
    move.w  $00(a1, d0), (Ctrl_2_Held).w
    rts
        
;=============================================================================== 
; Sub Routine Tails_RecordMoves
; [ Begin ]             
;===============================================================================    
Tails_RecordMoves: ; loc_11056:
    move.w  (Tails_Pos_Record_Index).w, d0
    lea     ($FFFFE700).w, a1
    lea     $00(a1, d0), a1
    move.w  x_pos(A0), (a1)+
    move.w  y_pos(A0), (a1)+
    addq.b  #4, ($FFFFEED7).w
    rts
;=============================================================================== 
; Sub Routine Tails_RecordMoves
; [ End ]             
;===============================================================================   
           
Tails_MdNormal: ; loc_11070:
    bsr     Tails_Spindash      ; loc_116D2
    bsr     Tails_Jump          ; loc_115E8
    bsr     Tails_SlopeResist       ; loc_1175E
    bsr     Tails_Move          ; loc_1110C
    bsr     Tails_Roll          ; loc_11582
    bsr     Tails_LevelBoundaries   ; loc_114FE
    jsr     SpeedToPos          ; loc_D27A
    bsr     Sonic_AnglePos      ; loc_12D28
    bsr     Tails_SlopeRepel    ; loc_117D0
    rts
Tails_MdJump: ; loc_11098:
    bsr     Tails_JumpHeight    ; loc_11696
    bsr     Tails_ChgJumpDir    ; loc_11484
    bsr     Tails_LevelBoundaries   ; loc_114FE
    jsr     ObjectFall          ; loc_D24E
    btst    #6, status(A0)
    beq.s   loc_110B8
    subi.w  #$28, y_vel(A0)
loc_110B8:
    bsr     Tails_JumpAngle     ; loc_11812
    bsr     Tails_Floor         ; loc_11872
    rts
Tails_MdRoll: ; loc_110C2:
    bsr     Tails_Jump          ; loc_115E8
    bsr     Tails_RollRepel     ; loc_11794
    bsr     Tails_RollSpeed     ; loc_1138C
    bsr     Tails_LevelBoundaries   ; loc_114FE
    jsr     SpeedToPos          ; loc_D27A
    bsr     Sonic_AnglePos      ; loc_12D28
    bsr     Tails_SlopeRepel    ; loc_117D0
    rts
Tails_MdJump2: ; loc_110E2:
    bsr     Tails_JumpHeight    ; loc_11696
    bsr     Tails_ChgJumpDir    ; loc_11484
    bsr     Tails_LevelBoundaries   ; loc_114FE
    jsr     ObjectFall          ; loc_D24E
    btst    #6, status(A0)
    beq.s   loc_11102
    subi.w  #$28, y_vel(A0)
loc_11102:
    bsr     Tails_JumpAngle     ; loc_11812
    bsr     Tails_Floor         ; loc_11872
    rts
        
;=============================================================================== 
; Sub Routine Tails_Move
; [ Begin ]             
;===============================================================================          
Tails_Move: ; loc_1110C:
    move.w  (Sonic_top_speed).w, d6
    move.w  (Sonic_acceleration).w, d5
    move.w  (Sonic_deceleration).w, d4
    tst.b   ($FFFFF7CA).w
    bne     loc_1121E
    tst.w   $2E(A0)
    bne     loc_111F2
    btst    #2, (Ctrl_2_Held).w
    beq.s   loc_11134
    bsr     Tails_MoveLeft      ; loc_112AE
loc_11134:
    btst    #3, (Ctrl_2_Held).w
    beq.s   loc_11140
    bsr     Tails_MoveRight     ; loc_11320
loc_11140:
    move.b  angle(A0), d0
    addi.b  #$20, d0
    andi.b  #$C0, d0
    bne     loc_111F2
    tst.w   inertia(A0)
    bne     loc_111F2
    bclr    #5, status(A0)
    move.b  #5, anim(A0)
    btst    #3, status(A0)
    beq.s   Tails_Balance       ; loc_111A2
    moveq   #0, d0
    move.b  $3D(A0), d0
    lsl.w   #6, d0
    lea     (MainCharacter).w, a1
    lea     $00(a1, d0), a1
    tst.b   status(a1)
    bmi.s   Tails_LookUp        ; loc_111D4
    moveq   #0, d1
    move.b  width_pixels(a1), d1
    move.w  d1, d2
    add.w   d2, d2
    subq.w  #4, d2
    add.w   x_pos(A0), d1
    sub.w   x_pos(a1), d1
    cmpi.w  #$4, d1
    blt.s   loc_111C6
    cmp.w   d2, d1
    bge.s   loc_111B6
    bra.s   Tails_LookUp        ; loc_111D4 
;=============================================================================== 
Tails_Balance: ; loc_111A2:
    jsr     ObjHitFloor         ; loc_13898
    cmpi.w  #$C, d1
    blt.s   Tails_LookUp        ; loc_111D4
    cmpi.b  #3, $36(A0)
    bne.s   loc_111BE
loc_111B6:
    bclr    #0, status(A0)
    bra.s   loc_111CC
loc_111BE:
    cmpi.b  #3, $37(A0)
    bne.s   Tails_LookUp        ; loc_111D4
loc_111C6:
    bset    #0, status(A0)
loc_111CC:
    move.b  #6, anim(A0)
    bra.s   loc_111F2
;===============================================================================           
Tails_LookUp: ; loc_111D4:
    btst    #0, (Ctrl_2_Held).w
    beq.s   loc_111E4
    move.b  #7, anim(A0)
    bra.s   loc_111F2
loc_111E4:
    btst    #1, (Ctrl_2_Held).w
    beq.s   loc_111F2
    move.b  #8, anim(A0)
loc_111F2:
    move.b  (Ctrl_2).w, d0
    andi.b  #$C, d0
    bne.s   loc_1121E
    move.w  inertia(A0), d0
    beq.s   loc_1121E
    bmi.s   loc_11212
    sub.w   d5, d0
    bcc.s   loc_1120C
    move.w  #$00, d0
loc_1120C:
    move.w  d0, inertia(A0)
    bra.s   loc_1121E
loc_11212:
    add.w   d5, d0
    bcc.s   loc_1121A
    move.w  #$00, d0
loc_1121A:
    move.w  d0, inertia(A0)
loc_1121E:
    move.b  angle(A0), d0
    jsr     CalcSine        ; loc_320A
    muls.w  inertia(A0), d1
    asr.l   #8, d1
    move.w  d1, x_vel(A0)
    muls.w  inertia(A0), d0
    asr.l   #8, d0
    move.w  d0, y_vel(A0)
loc_1123C:        
    move.b  angle(A0), d0
    addi.b  #$40, d0
    bmi.s   loc_112AC
    move.b  #$40, d1
    tst.w   inertia(A0)
    beq.s   loc_112AC
    bmi.s   loc_11254
    neg.w   d1
loc_11254:
    move.b  angle(A0), d0
    add.b   d1, d0
    move.w  d0, -(a7)
    bsr     Sonic_WalkSpeed     ; loc_1366C
    move.w  (a7)+, d0
    tst.w   d1
    bpl.s   loc_112AC
    asl.w   #8, d1
    addi.b  #$20, d0
    andi.b  #$C0, d0
    beq.s   loc_112A8
    cmpi.b  #$40, d0
    beq.s   loc_11296
    cmpi.b  #$80, d0
    beq.s   loc_11290
    add.w   d1, x_vel(A0)
    bset    #5, status(A0)
    move.w  #$00, inertia(A0)
    rts
loc_11290:
    sub.w   d1, y_vel(A0)
    rts
loc_11296:
    sub.w   d1, x_vel(A0)
    bset    #5, status(A0)
    move.w  #$00, inertia(A0)
    rts
loc_112A8:
    add.w   d1, y_vel(A0)
loc_112AC:
    rts
;=============================================================================== 
; Sub Routine Tails_Move
; [ End ]             
;=============================================================================== 

;=============================================================================== 
; Sub Routine Tails_MoveLeft
; [ Begin ]             
;===============================================================================           
Tails_MoveLeft: ; loc_112AE:
    move.w  inertia(A0), d0
    beq.s   loc_112B6
    bpl.s   loc_112E8
loc_112B6:
    bset    #0, status(A0)
    bne.s   loc_112CA
    bclr    #5, status(A0)
    move.b  #1, next_anim(A0)
loc_112CA:
    sub.w   d5, d0
    move.w  d6, d1
    neg.w   d1
    cmp.w   d1, d0
    bgt.s   loc_112DC
    add.w   d5, d0
    cmp.w   d1, d0
    ble.s   loc_112DC
    move.w  d1, d0
loc_112DC:
    move.w  d0, inertia(A0)
    move.b  #0, anim(A0)
    rts
loc_112E8:
    sub.w   d4, d0
    bcc.s   loc_112F0
    move.w  #$FF80, d0
loc_112F0:
    move.w  d0, inertia(A0)
    move.b  angle(A0), d0
    addi.b  #$20, d0
    andi.b  #$C0, d0
    bne.s   loc_1131E
    cmpi.w  #$400, d0
    blt.s   loc_1131E
    move.b  #$D, anim(A0)
    bclr    #0, status(A0)
    move.w  #$A4, d0
    jsr     (Play_Sfx)          ; loc_14C6
loc_1131E:
    rts
;=============================================================================== 
; Sub Routine Tails_MoveLeft
; [ End ]             
;===============================================================================   
          
;=============================================================================== 
; Sub Routine Tails_MoveRight
; [ Begin ]             
;===============================================================================         
Tails_MoveRight: ; loc_11320:
    move.w  inertia(A0), d0
    bmi.s   loc_11354
    bclr    #0, status(A0)
    beq.s   loc_1133A
    bclr    #5, status(A0)
    move.b  #1, next_anim(A0)
loc_1133A:
    add.w   d5, d0
    cmp.w   d6, d0
    blt.s   loc_11348
    sub.w   d5, d0
    cmp.w   d6, d0
    bge.s   loc_11348
    move.w  d6, d0
loc_11348:
    move.w  d0, inertia(A0)
    move.b  #0, anim(A0)
    rts
loc_11354:
    add.w   d4, d0
    bcc.s   loc_1135C
    move.w  #$80, d0
loc_1135C:
    move.w  d0, inertia(A0)
    move.b  angle(A0), d0
    addi.b  #$20, d0
    andi.b  #$C0, d0
    bne.s   loc_1138A
    cmpi.w  #$FC00, d0
    bgt.s   loc_1138A
    move.b  #$D, anim(A0)
    bset    #0, status(A0)
    move.w  #$A4, d0
    jsr     (Play_Sfx)          ; loc_14C6
loc_1138A:
    rts
;=============================================================================== 
; Sub Routine Tails_MoveRight
; [ End ]             
;===============================================================================  
         
;=============================================================================== 
; Sub Routine Tails_RollSpeed
; [ Begin ]             
;===============================================================================         
Tails_RollSpeed: ; loc_1138C:
    move.w  (Sonic_top_speed).w, d6
    asl.w   #1, d6
    move.w  (Sonic_acceleration).w, d5
    asr.w   #1, d5
    move.w  (Sonic_deceleration).w, d4
    asr.w   #2, d4
    tst.b   ($FFFFF7CA).w
    bne     loc_11408
    tst.w   $2E(A0)
    bne.s   loc_113C4
    btst    #2, (Ctrl_2_Held).w
    beq.s   loc_113B8
    bsr     Tails_RollLeft      ; loc_1143E
loc_113B8:
    btst    #3, (Ctrl_2_Held).w
    beq.s   loc_113C4
    bsr     Tails_RollRight     ; loc_11462
loc_113C4:
    move.w  inertia(A0), d0
    beq.s   loc_113E6
    bmi.s   loc_113DA
    sub.w   d5, d0
    bcc.s   loc_113D4
    move.w  #$00, d0
loc_113D4:
    move.w  d0, inertia(A0)
    bra.s   loc_113E6
loc_113DA:
    add.w   d5, d0
    bcc.s   loc_113E2
    move.w  #$00, d0
loc_113E2:
    move.w  d0, inertia(A0)
loc_113E6:
    tst.w   inertia(A0)
    bne.s   loc_11408
    bclr    #2, status(A0)
    move.b  #$F, y_radius(A0)
    move.b  #$9, x_radius(A0)
    move.b  #5, anim(A0)
    subq.w  #5, y_pos(A0)
loc_11408:
    move.b  angle(A0), d0
    jsr     CalcSine        ; loc_320A
    muls.w  inertia(A0), d0
    asr.l   #8, d0
    move.w  d0, y_vel(A0)
    muls.w  inertia(A0), d1
    asr.l   #8, d1
    cmpi.w  #$1000, d1
    ble.s   loc_1142C
    move.w  #$1000, d1
loc_1142C:
    cmpi.w  #$F000, d1
    bge.s   loc_11436
    move.w  #$F000, d1
loc_11436:
    move.w  d1, x_vel(A0)
    bra     loc_1123C
;=============================================================================== 
; Sub Routine Tails_RollSpeed
; [ End ]             
;===============================================================================
  
;=============================================================================== 
; Sub Routine Tails_RollLeft
; [ Begin ]             
;===============================================================================           
Tails_RollLeft: ; loc_1143E:
    move.w  inertia(A0), d0
    beq.s   loc_11446
    bpl.s   loc_11454
loc_11446:
    bset    #0, status(A0)
    move.b  #2, anim(A0)
    rts
loc_11454:
    sub.w   d4, d0
    bcc.s   loc_1145C
    move.w  #$FF80, d0
loc_1145C:
    move.w  d0, inertia(A0)
    rts
;=============================================================================== 
; Sub Routine Tails_RollLeft
; [ End ]             
;===============================================================================
   
;=============================================================================== 
; Sub Routine Tails_RollRight
; [ Begin ]             
;===============================================================================           
Tails_RollRight: ; loc_11462:
    move.w  inertia(A0), d0
    bmi.s   loc_11476
    bclr    #0, status(A0)
    move.b  #2, anim(A0)
    rts
loc_11476:
    add.w   d4, d0
    bcc.s   loc_1147E
    move.w  #$80, d0
loc_1147E:
    move.w  d0, inertia(A0)
    rts
;=============================================================================== 
; Sub Routine Tails_RollRight
; [ End ]             
;===============================================================================  
          
;=============================================================================== 
; Sub Routine Tails_ChgJumpDir
; [ Begin ]             
;===============================================================================          
Tails_ChgJumpDir: ; loc_11484:
    move.w  (Sonic_top_speed).w, d6
    move.w  (Sonic_acceleration).w, d5
    asl.w   #1, d5
    btst    #4, status(A0)
    bne.s   loc_114CE
    move.w  x_vel(A0), d0
    btst    #2, (Ctrl_2_Held).w
    beq.s   loc_114B4
    bset    #0, status(A0)
    sub.w   d5, d0
    move.w  d6, d1
    neg.w   d1
    cmp.w   d1, d0
    bgt.s   loc_114B4
    move.w  d1, d0
loc_114B4:
    btst    #3, (Ctrl_2_Held).w
    beq.s   loc_114CA
    bclr    #0, status(A0)
    add.w   d5, d0
    cmp.w   d6, d0
    blt.s   loc_114CA
    move.w  d6, d0
loc_114CA:
    move.w  d0, x_vel(A0)
loc_114CE:
    cmpi.w  #$FC00, y_vel(A0)
    bcs.s   loc_114FC
    move.w  x_vel(A0), d0
    move.w  d0, d1
    asr.w   #5, d1
    beq.s   loc_114FC
    bmi.s   loc_114F0
    sub.w   d1, d0
    bcc.s   loc_114EA
    move.w  #$00, d0
loc_114EA:
    move.w  d0, x_vel(A0)
    rts
loc_114F0:
    sub.w   d1, d0
    bcs.s   loc_114F8
    move.w  #$00, d0
loc_114F8:
    move.w  d0, x_vel(A0)
loc_114FC:
    rts 
;=============================================================================== 
; Sub Routine Tails_ChgJumpDir
; [ End ]             
;===============================================================================
            
;=============================================================================== 
; Sub Routine Tails_LevelBoundaries
; [ Begin ]             
;=============================================================================== 
Tails_LevelBoundaries: ; loc_114FE:
    move.l  x_pos(A0), d1
    move.w  x_vel(A0), d0
    ext.l   d0
    asl.l   #8, d0
    add.l   d0, d1
    swap.w  d1
    move.w  (Camera_Min_X_pos).w, d0
    addi.w  #$10, d0
    cmp.w   d1, d0
    bhi.s   loc_1156A
    move.w  (Camera_Max_X_pos).w, d0
    addi.w  #$128, d0
    tst.b   (Current_Boss_ID).w
    bne.s   loc_1152C
    addi.w  #$40, d0
loc_1152C:
    cmp.w   d1, d0
    bls.s   loc_1156A
loc_11530:        
    move.w  (Camera_Max_Y_pos_now).w, d0
    addi.w  #$E0, d0
    cmp.w   y_pos(A0), d0
    blt.s   loc_11540
    rts
loc_11540:
    bra     KillTails           ; loc_12074
    cmpi.w  #$501, (Current_ZoneAndAct).w
    bne     KillTails           ; loc_12074
    cmpi.w  #$2000, x_pos(A0)
    bcs     KillTails           ; loc_12074
    clr.b   (Last_star_pole_hit).w
    move.w  #$1, (Level_Inactive_flag).w
    move.w  #$103, (Current_ZoneAndAct).w
    rts
loc_1156A:
    move.w  d0, x_pos(A0)
    move.w  #$00, $A(A0)
    move.w  #$00, x_vel(A0)
    move.w  #$00, inertia(A0)
    bra.s   loc_11530
;=============================================================================== 
; Sub Routine Tails_LevelBoundaries
; [ End ]             
;===============================================================================  
           
;=============================================================================== 
; Sub Routine Tails_Roll
; [ Begin ]             
;===============================================================================           
Tails_Roll: ; loc_11582:
    tst.b   ($FFFFF7CA).w
    bne.s   loc_115A8
    move.w  inertia(A0), d0
    bpl.s   loc_11590
    neg.w   d0
loc_11590:
    cmpi.w  #$80, d0
    bcs.s   loc_115A8
    move.b  (Ctrl_2).w, d0
    andi.b  #$C, d0
    bne.s   loc_115A8
    btst    #1, (Ctrl_2_Held).w
    bne.s   loc_115AA
loc_115A8:
    rts
loc_115AA:
    btst    #2, status(A0)
    beq.s   loc_115B4
    rts
loc_115B4:
    bset    #2, status(A0)
    move.b  #$E, y_radius(A0)
    move.b  #7, x_radius(A0)
    move.b  #2, anim(A0)
    addq.w  #5, y_pos(A0)
    move.w  #$BE, d0
    jsr     (Play_Sfx)          ; loc_14C6
    tst.w   inertia(A0)
    bne.s   loc_115E6
    move.w  #$200, inertia(A0)
loc_115E6:
    rts
;=============================================================================== 
; Sub Routine Tails_Roll
; [ End ]             
;=============================================================================== 
         
;=============================================================================== 
; Sub Routine Tails_Jump
; [ Begin ]             
;===============================================================================          
Tails_Jump: ; loc_115E8:
    move.b  (Ctrl_2_Press).w, d0
    andi.b  #$70, d0
    beq     loc_1168C
    moveq   #0, d0
    move.b  angle(A0), d0
    addi.b  #$80, d0
    bsr     loc_136F2
    cmpi.w  #$6, d1
    blt     loc_1168C
    move.w  #$680, d2
    btst    #6, status(A0)
    beq.s   loc_1161A
    move.w  #$380, d2
loc_1161A:
    moveq   #0, d0
    move.b  angle(A0), d0
    subi.b  #$40, d0
    jsr     CalcSine        ; loc_320A
    muls.w  d2, d1
    asr.l   #8, d1
    add.w   d1, x_vel(A0)
    muls.w  d2, d0
    asr.l   #8, d0
    add.w   d0, y_vel(A0)
    bset    #1, status(A0)
    bclr    #5, status(A0)
    addq.l  #4, a7
    move.b  #1, $3C(A0)
    clr.b   $38(A0)
    move.w  #$A0, d0
    jsr     (Play_Sfx)          ; loc_14C6
    move.b  #$F, y_radius(A0)
    move.b  #$9, x_radius(A0)
    btst    #2, status(A0)
    bne.s   loc_1168E
    move.b  #$E, y_radius(A0)
    move.b  #7, x_radius(A0)
    move.b  #2, anim(A0)
    bset    #2, status(A0)
    addq.w  #5, y_pos(A0)
loc_1168C:
    rts
loc_1168E:
    bset    #4, status(A0)
    rts
;=============================================================================== 
; Sub Routine Tails_Jump
; [ End ]             
;===============================================================================     
          
;=============================================================================== 
; Sub Routine Tails_JumpHeight
; [ Begin ]             
;===============================================================================           
Tails_JumpHeight: ; loc_11696:
    tst.b   $3C(A0)
    beq.s   loc_116C2
    move.w  #$FC00, d1
    btst    #6, status(A0)
    beq.s   loc_116AC
    move.w  #$FE00, d1
loc_116AC:
    cmp.w   y_vel(A0), d1
    ble.s   loc_116C0
    move.b  (Ctrl_2).w, d0
    andi.b  #$70, d0
    bne.s   loc_116C0
    move.w  d1, y_vel(A0)
loc_116C0:
    rts
loc_116C2:
    cmpi.w  #$F040, y_vel(A0)
    bge.s   loc_116D0
    move.w  #$F040, y_vel(A0)
loc_116D0:
    rts
;=============================================================================== 
; Sub Routine Tails_JumpHeight
; [ End ]             
;=============================================================================== 
         
;=============================================================================== 
; Sub Routine Tails_Spindash
; [ Begin ]             
;===============================================================================          
Tails_Spindash: ; loc_116D2:
    tst.b   $39(A0)
    bne.s   loc_11706
    cmpi.b  #8, anim(A0)
    bne.s   loc_11704
    move.b  (Ctrl_2_Press).w, d0
    andi.b  #$70, d0
    beq     loc_11704
    move.b  #$9, anim(A0)
    move.w  #$BE, d0
    jsr     (Play_Sfx)          ; loc_14C6
    addq.l  #4, a7
    move.b  #1, $39(A0)
loc_11704:
    rts
loc_11706:
    move.b  (Ctrl_2).w, d0
    btst    #1, d0
    bne.s   loc_1174C
    move.b  #$E, y_radius(A0)
    move.b  #7, x_radius(A0)
    move.b  #2, anim(A0)
    addq.w  #5, y_pos(A0)
    move.b  #0, $39(A0)
    move.w  #$2000, ($FFFFEED4).w
    move.w  #$800, inertia(A0)
    btst    #0, status(A0)
    beq.s   loc_11744
    neg.w   inertia(A0)
loc_11744:
    bset    #2, status(A0)
    rts
loc_1174C:
    move.b  (Ctrl_2_Press).w, d0
    andi.b  #$70, d0
    beq     loc_1175A
    nop
loc_1175A:
    addq.l  #4, a7
    rts   
;=============================================================================== 
; Sub Routine Tails_Spindash
; [ End ]             
;===============================================================================   
 
;=============================================================================== 
; Sub Routine Tails_SlopeResist
; [ Begin ]             
;===============================================================================           
Tails_SlopeResist: ; loc_1175E:
    move.b  angle(A0), d0
    addi.b  #$60, d0
    cmpi.b  #$C0, d0
    bcc.s   loc_11792
    move.b  angle(A0), d0
    jsr     CalcSine        ; loc_320A
    muls.w  #$20, d0
    asr.l   #8, d0
    tst.w   inertia(A0)
    beq.s   loc_11792
    bmi.s   loc_1178E
    tst.w   d0
    beq.s   loc_1178C
    add.w   d0, inertia(A0)
loc_1178C:
    rts
loc_1178E:
    add.w   d0, inertia(A0)
loc_11792:
    rts
;=============================================================================== 
; Sub Routine Tails_SlopeResist
; [ End ]             
;===============================================================================     
         
;=============================================================================== 
; Sub Routine Tails_RollRepel
; [ Begin ]             
;===============================================================================           
Tails_RollRepel: ; loc_11794:
    move.b  angle(A0), d0
    addi.b  #$60, d0
    cmpi.b  #$C0, d0
    bcc.s   loc_117CE
    move.b  angle(A0), d0
    jsr     CalcSine        ; loc_320A
    muls.w  #$50, d0
    asr.l   #8, d0
    tst.w   inertia(A0)
    bmi.s   loc_117C4
    tst.w   d0
    bpl.s   loc_117BE
    asr.l   #2, d0
loc_117BE:
    add.w   d0, inertia(A0)
    rts
loc_117C4:
    tst.w   d0
    bmi.s   loc_117CA
    asr.l   #2, d0
loc_117CA:
    add.w   d0, inertia(A0)
loc_117CE:
    rts
;=============================================================================== 
; Sub Routine Tails_RollRepel
; [ End ]             
;===============================================================================   
        
;=============================================================================== 
; Sub Routine Tails_SlopeRepel
; [ Begin ]             
;===============================================================================          
Tails_SlopeRepel: ; loc_117D0:
    nop
    tst.b   $38(A0)
    bne.s   loc_1180A
    tst.w   $2E(A0)
    bne.s   loc_1180C
    move.b  angle(A0), d0
    addi.b  #$20, d0
    andi.b  #$C0, d0
    beq.s   loc_1180A
    move.w  inertia(A0), d0
    bpl.s   loc_117F4
    neg.w   d0
loc_117F4:
    cmpi.w  #$280, d0
    bcc.s   loc_1180A
    clr.w   inertia(A0)
    bset    #1, status(A0)
    move.w  #$1E, $2E(A0)
loc_1180A:
    rts
loc_1180C:
    subq.w  #1, $2E(A0)
    rts
;=============================================================================== 
; Sub Routine Tails_SlopeRepel
; [ End ]             
;===============================================================================  
         
;=============================================================================== 
; Sub Routine Tails_JumpAngle
; [ Begin ]             
;===============================================================================          
Tails_JumpAngle: ; loc_11812:
    move.b  angle(A0), d0
    beq.s   loc_1182C
    bpl.s   loc_11822
    addq.b  #2, d0
    bcc.s   loc_11820
    moveq   #0, d0
loc_11820:
    bra.s   loc_11828
loc_11822:
    subq.b  #2, d0
    bcc.s   loc_11828
    moveq   #0, d0
loc_11828:
    move.b  d0, angle(A0)
loc_1182C:
    move.b  flip_angle(A0), d0
    beq.s   loc_11870
    tst.w   inertia(A0)
    bmi.s   loc_11850
loc_11838:        
    move.b  $2D(A0), d1
    add.b   d1, d0
    bcc.s   loc_1184E
    subq.b  #1, $2C(A0)
    bcc.s   loc_1184E
    move.b  #0, $2C(A0)
    moveq   #0, d0
loc_1184E:
    bra.s   loc_1186C
loc_11850:
    tst.b   flip_turned(A0)
    bne.s   loc_11838
    move.b  $2D(A0), d1
    sub.b   d1, d0
    bcc.s   loc_1186C
    subq.b  #1, $2C(A0)
    bcc.s   loc_1186C
    move.b  #0, $2C(A0)
    moveq   #0, d0
loc_1186C:
    move.b  d0, flip_angle(A0)
loc_11870:
    rts
;=============================================================================== 
; Sub Routine Tails_JumpAngle
; [ End ]             
;===============================================================================     
         
;=============================================================================== 
; Sub Routine Tails_Floor
; [ Begin ]             
;===============================================================================           
Tails_Floor: ; loc_11872:
    move.b  $3F(A0), d5
    move.w  x_vel(A0), d1
    move.w  y_vel(A0), d2
    jsr     CalcAngle           ; loc_34A2
    move.b  d0, $2B(A0)
    subi.b  #$20, d0
    andi.b  #$C0, d0
    cmpi.b  #$40, d0
    beq     loc_11946
    cmpi.b  #$80, d0
    beq     loc_119A8
    cmpi.b  #$C0, d0
    beq     loc_11A04
    bsr     Sonic_HitWall       ; loc_13AFC
    tst.w   d1
    bpl.s   loc_118BA
    sub.w   d1, x_pos(A0)
    move.w  #$00, x_vel(A0)
loc_118BA:
    bsr     loc_1397A
    tst.w   d1
    bpl.s   loc_118CC
    add.w   d1, x_pos(A0)
    move.w  #$00, x_vel(A0)
loc_118CC:
    bsr     loc_13736
    tst.w   d1
    bpl.s   loc_11944
    move.b  y_vel(A0), d2
    addq.b  #8,  d2
    neg.b   d2
    cmp.b   d2, d1
    bge.s   loc_118E4
    cmp.b   d2, d0
    blt.s   loc_11944
loc_118E4:
    add.w   d1, y_pos(A0)
    move.b  d3, angle(A0)
    bsr     Tails_ResetTailsOnFloor ; loc_11A66
    move.b  #0, anim(A0)
    move.b  d3, d0
    addi.b  #$20, d0
    andi.b  #$40, d0
    bne.s   loc_11922
    move.b  d3, d0
    addi.b  #$10, d0
    andi.b  #$20, d0
    beq.s   loc_11914
    asr.w   y_vel(A0)
    bra.s   loc_11936
loc_11914:
    move.w  #$00, y_vel(A0)
    move.w  x_vel(A0), inertia(A0)
    rts
loc_11922:
    move.w  #$00, x_vel(A0)
    cmpi.w  #$FC0, y_vel(A0)
    ble.s   loc_11936
    move.w  #$FC0, y_vel(A0)
loc_11936:
    move.w  y_vel(A0), inertia(A0)
    tst.b   d3
    bpl.s   loc_11944
    neg.w   inertia(A0)
loc_11944:
    rts
loc_11946:
    bsr     Sonic_HitWall       ; loc_13AFC
    tst.w   d1
    bpl.s   loc_11960
    sub.w   d1, x_pos(A0)
    move.w  #$00, x_vel(A0)
    move.w  y_vel(A0), inertia(A0)
    rts
loc_11960:
    bsr     Sonic_DontRunOnWalls    ; loc_139CC
    tst.w   d1
    bpl.s   loc_1197A
    sub.w   d1, y_pos(A0)
    tst.w   y_vel(A0)
    bpl.s   loc_11978
    move.w  #$00, y_vel(A0)
loc_11978:
    rts
loc_1197A:
    tst.w   y_vel(A0)
    bmi.s   loc_119A6
    bsr     loc_13736
    tst.w   d1
    bpl.s   loc_119A6
    add.w   d1, y_pos(A0)
    move.b  d3, angle(A0)
    bsr     Tails_ResetTailsOnFloor ; loc_11A66
    move.b  #0, anim(A0)
    move.w  #$00, y_vel(A0)
    move.w  x_vel(A0), inertia(A0)
loc_119A6:
    rts
loc_119A8:
    bsr     Sonic_HitWall       ; loc_13AFC
    tst.w   d1
    bpl.s   loc_119BA
    sub.w   d1, x_pos(A0)
    move.w  #$00, x_vel(A0)
loc_119BA:
    bsr     loc_1397A
    tst.w   d1
    bpl.s   loc_119CC
    add.w   d1, x_pos(A0)
    move.w  #$00, x_vel(A0)
loc_119CC:
    bsr     Sonic_DontRunOnWalls    ; loc_139CC
    tst.w   d1
    bpl.s   loc_11A02
    sub.w   d1, y_pos(A0)
    move.b  d3, d0
    addi.b  #$20, d0
    andi.b  #$40, d0
    bne.s   loc_119EC
    move.w  #$00, y_vel(A0)
    rts
loc_119EC:
    move.b  d3, angle(A0)
    bsr     Tails_ResetTailsOnFloor ; loc_11A66
    move.w  y_vel(A0), inertia(A0)
    tst.b   d3
    bpl.s   loc_11A02
    neg.w   inertia(A0)
loc_11A02:
    rts
loc_11A04:
    bsr     loc_1397A
    tst.w   d1
    bpl.s   loc_11A1E
    add.w   d1, x_pos(A0)
    move.w  #$00, x_vel(A0)
    move.w  y_vel(A0), inertia(A0)
    rts
loc_11A1E:
    bsr     Sonic_DontRunOnWalls    ; loc_139CC
    tst.w   d1
    bpl.s   loc_11A38
    sub.w   d1, y_pos(A0)
    tst.w   y_vel(A0)
    bpl.s   loc_11A36
    move.w  #$00, y_vel(A0)
loc_11A36:
    rts
loc_11A38:
    tst.w   y_vel(A0)
    bmi.s   loc_11A64
    bsr     loc_13736
    tst.w   d1
    bpl.s   loc_11A64
    add.w   d1, y_pos(A0)
    move.b  d3, angle(A0)
    bsr     Tails_ResetTailsOnFloor ; loc_11A66
    move.b  #0, anim(A0)
    move.w  #$00, y_vel(A0)
    move.w  x_vel(A0), inertia(A0)
loc_11A64:
    rts  
;=============================================================================== 
; Sub Routine Tails_Floor
; [ End ]             
;===============================================================================          
              
;=============================================================================== 
; Object 0x02 - Tails
; [ End ]
;=============================================================================== 

;=============================================================================== 
; Sub Routine Tails_ResetTailsOnFloor
; [ Begin ]             
;===============================================================================           
Tails_ResetTailsOnFloor: ; loc_11A66:
    btst    #4, status(A0)
    beq.s   loc_11A74
    nop
    nop
    nop
loc_11A74:
    bclr    #5, status(A0)
    bclr    #1, status(A0)
    bclr    #4, status(A0)
    btst    #2, status(A0)
    beq.s   loc_11AAA
    bclr    #2, status(A0)
    move.b  #$F, y_radius(A0)
    move.b  #$9, x_radius(A0)
    move.b  #0, anim(A0)
    subq.w  #1, y_pos(A0)
loc_11AAA:
    move.b  #0, $3C(A0)
    move.w  #$00, (Chain_Bonus_counter).w
    move.b  #0, flip_angle(A0)
    move.b  #0, flip_turned(A0)
    rts  
;=============================================================================== 
; Sub Routine Tails_ResetTailsOnFloor
; [ End ]             
;=============================================================================== 
           
Tails_Hurt: ; loc_11AC4:
    jsr     SpeedToPos          ; loc_D27A
    addi.w  #$30, y_vel(A0)
    btst    #6, status(A0)
    beq.s   loc_11ADE
    subi.w  #$20, y_vel(A0)
loc_11ADE:
    bsr     Tails_HurtStop      ; loc_11AF4
    bsr     Tails_LevelBoundaries   ; loc_114FE
    bsr     Tails_Animate       ; loc_11BA2
    bsr     Load_Tails_Dynamic_PLC  ; loc_11F42
    jmp     DisplaySprite       ; loc_D3C2
        
;=============================================================================== 
; Sub Routine Tails_HurtStop
; [ Begin ]             
;===============================================================================         
Tails_HurtStop: ; loc_11AF4:
    move.w  (Camera_Max_Y_pos_now).w, d0
    addi.w  #$E0, d0
    cmp.w   y_pos(A0), d0
    bcs     KillTails           ; loc_12074
    bsr     Tails_Floor         ; loc_11872
    btst    #1, status(A0)
    bne.s   loc_11B30
    moveq   #0, d0
    move.w  d0, y_vel(A0)
    move.w  d0, x_vel(A0)
    move.w  d0, inertia(A0)
    move.b  #0, anim(A0)
    move.b  #2, routine(A0)
    move.w  #$78, $30(A0)
loc_11B30:
    rts
;=============================================================================== 
; Sub Routine Tails_HurtStop
; [ End ]             
;===============================================================================          
        
Tails_Death: ; loc_11B32:
    bsr     Tails_GameOver      ; loc_11B4A
    jsr     ObjectFall          ; loc_D24E
    bsr     Tails_Animate       ; loc_11BA2
    bsr     Load_Tails_Dynamic_PLC  ; loc_11F42
    jmp     DisplaySprite       ; loc_D3C2
        
;=============================================================================== 
; Sub Routine Tails_GameOver
; [ Begin ]             
;===============================================================================         
Tails_GameOver: ; loc_11B4A:
    move.w  (Camera_Max_Y_pos_now).w, d0
    addi.w  #$100, d0
    cmp.w   y_pos(A0), d0
    bcc     loc_11B8C
    move.w  ($FFFFB008).w, d0
    subi.w  #$40, d0
    move.w  d0, x_pos(A0)
    move.w  ($FFFFB00C).w, d0
    subi.w  #$80, d0
    move.w  d0, y_pos(A0)
    move.b  #2, routine(A0)
    andi.w  #$7FFF, $2(A0)
    move.b  #$C, $3E(A0)
    move.b  #$D, $3F(A0)
    nop
loc_11B8C:
    rts
;=============================================================================== 
; Sub Routine Tails_GameOver
; [ End ]             
;===============================================================================
         
Tails_ResetLevel: ; loc_11B8E:
    tst.w   $3A(A0)
    beq.s   loc_11BA0
    subq.w  #1, $3A(A0)
    bne.s   loc_11BA0
    move.w  #$1, (Level_Inactive_flag).w
loc_11BA0:
    rts
        
;=============================================================================== 
; Sub Routine Tails_Animate
; [ Begin ]             
;===============================================================================    
Tails_Animate: ; loc_11BA2: ; Tails Subroutine  
    lea     (Tails_AnimateData), a1 ; loc_11DF4
Tails_Animate2: ; loc_11BA8:        
    moveq   #0, d0
    move.b  anim(A0), d0
    cmp.b   next_anim(A0), d0
    beq.s   loc_11BCA
    move.b  d0, next_anim(A0)
    move.b  #0, anim_frame(A0)
    move.b  #0, anim_frame_duration(A0)
    bclr    #5, status(A0)
loc_11BCA:
    add.w   d0, d0
    adda.w  $00(a1, d0), a1
    move.b  (a1), d0
    bmi.s   loc_11C3A
    move.b  status(A0), d1
    andi.b  #1, d1
    andi.b  #$FC, $1(A0)
    or.b    d1, $1(A0)
    subq.b  #1, anim_frame_duration(A0)
    bpl.s   loc_11C08
    move.b  d0, anim_frame_duration(A0)
loc_11BF0:        
    moveq   #0, d1
    move.b  anim_frame(A0), d1
    move.b  $1(a1, d1), d0
    cmpi.b  #$F0, d0          
    bcc.s   loc_11C0A
loc_11C00:        
    move.b  d0, mapping_frame(A0)
    addq.b  #1, anim_frame(A0)
loc_11C08:
    rts
loc_11C0A:
    addq.b  #1, d0
    bne.s   loc_11C1A
    move.b  #0, anim_frame(A0)
    move.b  $1(a1), d0
    bra.s   loc_11C00
loc_11C1A:
    addq.b  #1, d0
    bne.s   loc_11C2E
    move.b  $2(a1, d1), d0
    sub.b   d0, anim_frame(A0)
    sub.b   d0, d1
    move.b  $1(a1, d1), d0
    bra.s   loc_11C00
loc_11C2E:
    addq.b  #1, d0
    bne.s   loc_11C38
    move.b  $2(a1, d1), anim(A0)
loc_11C38:
    rts
loc_11C3A:
    subq.b  #1, anim_frame_duration(A0)
    bpl.s   loc_11C08
    addq.b  #1, d0
    bne     loc_11D26
    moveq   #0, d0
    move.b  flip_angle(A0), d0
    bne     loc_11CC0
    moveq   #0, d1
    move.b  angle(A0), d0
    move.b  status(A0), d2
    andi.b  #1, d2
    bne.s   loc_11C62
    not.b  d0
loc_11C62:
    addi.b  #$10, d0
    bpl.s   loc_11C6A
    moveq   #3, d1
loc_11C6A:
    andi.b  #$FC, $1(A0)
    eor.b   d1, d2
    or.b    d2, $1(A0)
    lsr.b   #4, d0
    andi.b  #6, d0
    move.w  inertia(A0), d2
    bpl.s   loc_11C84
    neg.w   d2
loc_11C84:
    move.b  d0, d3
    add.b   d3, d3
    add.b   d3, d3
    lea     (Tails_Animate_Walk), a1 ; loc_11E32
    cmpi.w  #$600, d2
    bcs.s   loc_11CA6
    lea     (Tails_Animate_Run), a1 ; loc_11E3C
    move.b  d0, d1
    lsr.b   #1, d1
    add.b   d1, d0
    add.b   d0, d0
    move.b  d0, d3
loc_11CA6:
    neg.w   d2
    addi.w  #$800, d2
    bpl.s   loc_11CB0
    moveq   #0, d2
loc_11CB0:
    lsr.w   #8, d2
    move.b  d2, anim_frame_duration(A0)
    bsr     loc_11BF0
    add.b   d3, mapping_frame(A0)
    rts
loc_11CC0:
    move.b  flip_angle(A0), d0
    moveq   #0, d1
    move.b  status(A0), d2
    andi.b  #1, d2
    bne.s   loc_11CEE
    andi.b  #$FC, $1(A0)
    addi.b  #$B, d0
    divu.w  #$16, d0
    addi.b  #$75, d0
    move.b  d0, mapping_frame(A0)
    move.b  #0, anim_frame_duration(A0)
    rts
loc_11CEE:
    andi.b  #$FC, $1(A0)
    tst.b   flip_turned(A0)
    beq.s   loc_11D06
    ori.b   #1, $1(A0)
    addi.b  #$B, d0
    bra.s   loc_11D12
loc_11D06:
    ori.b   #3, $1(A0)
    neg.b   d0
    addi.b  #$8F, d0
loc_11D12:
    divu.w  #$16, d0
    addi.b  #$75, d0
    move.b  d0, mapping_frame(A0)
    move.b  #0, anim_frame_duration(A0)
    rts
loc_11D26:
    addq.b  #1, d0
    bne.s   loc_11D6A
    move.w  inertia(A0), d2
    bpl.s   loc_11D32
    neg.w   d2
loc_11D32:
    lea     (Tails_Animate_Roll2), a1 ; loc_11E4B
    cmpi.w  #$600, d2
    bcc.s   loc_11D44
    lea     (Tails_Animate_Roll), a1 ; loc_11E46
loc_11D44:
    neg.w   d2
    addi.w  #$400, d2
    bpl.s   loc_11D4E
    moveq   #0, d2
loc_11D4E:
    lsr.w   #8, d2
    move.b  d2, anim_frame_duration(A0)
    move.b  status(A0), d1
    andi.b  #1, d1
    andi.b  #$FC, $1(A0)
    or.b    d1, $1(A0)
    bra     loc_11BF0
loc_11D6A:
    addq.b  #1, d0
    bne.s   loc_11DA0
    move.w  inertia(A0), d2
    bmi.s   loc_11D76
    neg.w   d2
loc_11D76:
    addi.w  #$800, d2
    bpl.s   loc_11D7E
    moveq   #0, d2
loc_11D7E:
    lsr.w   #6, d2
    move.b  d2, anim_frame_duration(A0)
    lea     (Tails_Animate_Push_NoArt), a1 ; loc_11E50
    move.b  status(A0), d1
    andi.b  #1, d1
    andi.b  #$FC, $1(A0)
    or.b    d1, $1(A0)
    bra     loc_11BF0
loc_11DA0:
    move.w  ($FFFFB050).w, d1
    move.w  ($FFFFB052).w, d2
    jsr     CalcAngle           ; loc_34A2
    moveq   #0, d1
    move.b  status(A0), d2
    andi.b  #1, d2
    bne.s   loc_11DBE
    not.b  d0
    bra.s   loc_11DC2
loc_11DBE:
    addi.b  #$80, d0
loc_11DC2:
    addi.b  #$10, d0
    bpl.s   loc_11DCA
    moveq   #3, d1
loc_11DCA:
    andi.b  #$FC, $1(A0)
    eor.b   d1, d2
    or.b    d2, $1(A0)
    lsr.b   #3, d0
    andi.b  #$C, d0
    move.b  d0, d3
    lea     (loc_12054), a1
    move.b  #3, anim_frame_duration(A0)
    bsr     loc_11BF0
    add.b   d3, mapping_frame(A0)
    rts 
Tails_AnimateData: ; loc_11DF4: ; Tails Data           
    dc.w    Tails_Animate_Walk-Tails_AnimateData       ; loc_11E32
    dc.w    Tails_Animate_Run-Tails_AnimateData        ; loc_11E3C
    dc.w    Tails_Animate_Roll-Tails_AnimateData       ; loc_11E46
    dc.w    Tails_Animate_Roll2-Tails_AnimateData      ; loc_11E4B
    dc.w    Tails_Animate_Push_NoArt-Tails_AnimateData     ; loc_11E50
    dc.w    Tails_Animate_Wait-Tails_AnimateData       ; loc_11E58
    dc.w    Tails_Animate_Balance_NoArt-Tails_AnimateData  ; loc_11E96
    dc.w    Tails_Animate_LookUp-Tails_AnimateData     ; loc_11EA0
    dc.w    Tails_Animate_Duck-Tails_AnimateData       ; loc_11EA3
    dc.w    Tails_Animate_Spindash-Tails_AnimateData       ; loc_11EA6
    dc.w    Tails_Animate_0x0A-Tails_AnimateData       ; loc_11EAB
    dc.w    Tails_Animate_0x0B-Tails_AnimateData       ; loc_11EAE
    dc.w    Tails_Animate_0x0C-Tails_AnimateData       ; loc_11EB4
    dc.w    Tails_Animate_Stop-Tails_AnimateData       ; loc_11EB8
    dc.w    Tails_Animate_Fly-Tails_AnimateData        ; loc_11EBC
    dc.w    Tails_Animate_0x0F-Tails_AnimateData       ; loc_11EC0
    dc.w    Tails_Animate_Jump-Tails_AnimateData       ; loc_11EC7
    dc.w    Tails_Animate_0x11-Tails_AnimateData       ; loc_11ED6
    dc.w    Tails_Animate_0x12-Tails_AnimateData       ; loc_11EDA
    dc.w    Tails_Animate_0x13-Tails_AnimateData       ; loc_11EE0
    dc.w    Tails_Animate_0x14-Tails_AnimateData       ; loc_11EE5
    dc.w    Tails_Animate_0x15-Tails_AnimateData       ; loc_11EE8
    dc.w    Tails_Animate_Death1-Tails_AnimateData     ; loc_11EEF
    dc.w    Tails_Animate_Unused_Drown-Tails_AnimateData   ; loc_11EF2
    dc.w    Tails_Animate_Death2-Tails_AnimateData     ; loc_11EF5
    dc.w    Tails_Animate_0x19-Tails_AnimateData       ; loc_11EF8
    dc.w    Tails_Animate_0x1A-Tails_AnimateData       ; loc_11EFB
    dc.w    Tails_Animate_0x1B-Tails_AnimateData       ; loc_11EFE
    dc.w    Tails_Animate_0x1C-Tails_AnimateData       ; loc_11F02
    dc.w    Tails_Animate_0x1D-Tails_AnimateData       ; loc_11F06
    dc.w    Tails_Animate_0x1E-Tails_AnimateData       ; loc_11F10
Tails_Animate_Walk: ; loc_11E32:
    dc.b    $FF, $10, $11, $12, $13, $14, $15, $E, $F, $FF  
Tails_Animate_Run: ; loc_11E3C:
    dc.b    $FF, $2E, $2F, $30, $31, $FF, $FF, $FF, $FF, $FF
Tails_Animate_Roll: ; loc_11E46:
    dc.b    $1, $48, $47, $46, $FF
Tails_Animate_Roll2: ; loc_11E4B:
    dc.b    $1, $48, $47, $46, $FF
Tails_Animate_Push_NoArt: ; loc_11E50:
    dc.b    $FD, $9, $A, $B, $C, $D, $E, $FF
Tails_Animate_Wait: ; loc_11E58:
    dc.b    $7, $1, $1, $1, $1, $1, $1, $1, $1, $1, $1, $3, $2, $1, $1, $1
    dc.b    $1, $1, $1, $1, $1, $3, $2, $1, $1, $1, $1, $1, $1, $1, $1, $1
    dc.b    $5, $5, $5, $5, $5, $5, $5, $5, $5, $5, $5, $5, $5, $5, $5, $5
    dc.b    $6, $7, $8, $7, $8, $7, $8, $7, $8, $7, $8, $6, $FE, $1C  
Tails_Animate_Balance_NoArt: ; loc_11E96:
    dc.b    $1F, $1, $2, $3, $4, $5, $6, $7, $8, $FF
Tails_Animate_LookUp: ; loc_11EA0:
    dc.b    $3F, $4, $FF
Tails_Animate_Duck: ; loc_11EA3:
    dc.b    $3F, $5B, $FF
Tails_Animate_Spindash: ; loc_11EA6:
    dc.b    $00, $60, $61, $62, $FF
Tails_Animate_0x0A: ; loc_11EAB:
    dc.b    $3F, $82, $FF
Tails_Animate_0x0B: ; loc_11EAE:
    dc.b    $7, $8, $8, $9, $FD, $5
Tails_Animate_0x0C: ; loc_11EB4:
    dc.b    $7, $9, $FD, $5
Tails_Animate_Stop: ; loc_11EB8:
    dc.b    $7, $1, $2, $FF
Tails_Animate_Fly: ; loc_11EBC:
    dc.b    $7, $5E, $5F, $FF
Tails_Animate_0x0F: ; loc_11EC0:
    dc.b    $7, $1, $2, $3, $4, $5, $FF
Tails_Animate_Jump: ; loc_11EC7:
    dc.b    $3, $59, $5A, $59, $5A, $59, $5A, $59, $5A, $59, $5A, $59, $5A, $FD, $00
Tails_Animate_0x11: ; loc_11ED6:
    dc.b    $4, $1, $2, $FF
Tails_Animate_0x12: ; loc_11EDA:
    dc.b    $F, $1, $2, $3, $FE, $1
Tails_Animate_0x13: ; loc_11EE0:
    dc.b    $F, $1, $2, $FE, $1
Tails_Animate_0x14: ; loc_11EE5:
    dc.b    $3F, $1, $FF
Tails_Animate_0x15: ; loc_11EE8:
    dc.b    $B, $1, $2, $3, $4, $FD, $00
Tails_Animate_Death1: ; loc_11EEF:
    dc.b    $20, $5D, $FF
Tails_Animate_Unused_Drown: ; loc_11EF2:
    dc.b    $2F, $5D, $FF
Tails_Animate_Death2: ; loc_11EF5:
    dc.b    $3, $5D, $FF
Tails_Animate_0x19: ; loc_11EF8:
    dc.b    $3, $5D, $FF
Tails_Animate_0x1A: ; loc_11EFB:
    dc.b    $3, $5C, $FF
Tails_Animate_0x1B: ; loc_11EFE:
    dc.b    $7, $1, $1, $FF
Tails_Animate_0x1C: ; loc_11F02:
    dc.b    $77, $00, $FD, $00
Tails_Animate_0x1D: ; loc_11F06:
    dc.b    $3, $1, $2, $3, $4, $5, $6, $7, $8, $FF
Tails_Animate_0x1E: ; loc_11F10:
    dc.b    $3, $1, $2, $3, $4, $5, $6, $7, $8, $FF
;=============================================================================== 
; Sub Routine Tails_Animate
; [ End ]             
;=============================================================================== 

;=============================================================================== 
; Sub Routine Load_Tails_Tail_Dynamic_PLC
; [ Begin ]             
;===============================================================================    
Load_Tails_Tail_Dynamic_PLC: ; loc_11F1A:  ; Tails "Tail" subroutine
    moveq   #0, d0
    move.b  mapping_frame(A0), d0
    cmp.b   ($FFFFF7DF).w, d0
    beq.s   loc_11F94
    move.b  d0, ($FFFFF7DF).w
    lea     (Tails_Dyn_Script), a2  ; loc_7056E
    add.w   d0, d0
    adda.w  $00(a2, d0), a2
    move.w  (a2)+, d5
    subq.w  #1, d5
    bmi.s   loc_11F94
    move.w  #$F600, d4
    bra.s   loc_11F68  
;=============================================================================== 
Load_Tails_Dynamic_PLC: ; loc_11F42:
    moveq   #0, d0
    move.b  mapping_frame(A0), d0
    cmp.b   ($FFFFF7DE).w, d0
    beq.s   loc_11F94
    move.b  d0, ($FFFFF7DE).w
    lea     (Tails_Dyn_Script), a2 ; loc_7056E
    add.w   d0, d0
    adda.w  $00(a2, d0), a2
    move.w  (a2)+, d5
    subq.w  #1, d5
    bmi.s   loc_11F94
    move.w  #$F400, d4
loc_11F68:        
    moveq   #0, d1
    move.w  (a2)+, d1
    move.w  d1, d3
    lsr.w   #8, d3
    andi.w  #$F0, d3
    addi.w  #$10, d3
    andi.w  #$FFF, d1
    lsl.l   #5, d1
    addi.l  #Tails_Sprites, d1      ; loc_6254C
    move.w  d4, d2
    add.w   d3, d4
    add.w   d3, d4
    jsr     DMA_68KtoVRAM       ; loc_156C
    dbra    d5, loc_11F68
loc_11F94:
    rts      	