;--------------------------------------------------------
; Green Hill Zone/Hill Top Zone Art
;--------------------------------------------------------	
Green_Hill_8x8_Tiles: ; loc_ABF2A: 
	incbin  'data\ghz\Tiles\ghz.bin'  
Green_Hill_16x16_Map: ; loc_AB5CA:
	incbin  'data\ghz\blocks\ghz.bin'    
Green_Hill_128x128_Map: ; loc_AF026:        
    incbin  'data\ghz\Chunks\ghz.bin'  

;--------------------------------------------------------
; Hill Top Zone Art
;--------------------------------------------------------
Hill_Top_16x16_Map: ; loc_84A50:    
	incbin  'data\htz\blocks\htz.bin'                  
Hill_Top_8x8_Tiles: ; loc_85200:  
	incbin  'data\htz\Tiles\htz.bin'                
Htz_Init_Sprites_Dyn_Reload: ; loc_86626:    
	incbin  'data\htz\DynLevel\init_spr.bin'                     
;--------------------------------------------------------
; Wood Zone Art
;--------------------------------------------------------	
Wood_8x8_Tiles: ; loc_ABF2A: 
	incbin  'data\wz\Tiles\wz.bin'  
Wood_16x16_Map: ; loc_AB5CA:
	incbin  'data\wz\blocks\wz.bin'    
Wood_128x128_Map: ; loc_AF026:        
    incbin  'data\wz\Chunks\wz.bin'  
	even  
Waterfall: ; loc_8E6C6:  
        incbin  'art\Nemesis\Objects\watrfall.bin' 	
;--------------------------------------------------------
; Metropolis Zone Art
;--------------------------------------------------------	
Metropolis_8x8_Tiles: ; loc_ABF2A: 
	incbin  'data\mz\Tiles\mz.bin'  
Metropolis_16x16_Map: ; loc_AB5CA:
	incbin  'data\mz\blocks\mz.bin'    
Metropolis_128x128_Map: ; loc_AF026:        
    incbin  'data\mz\Chunks\mz.bin'  
	even  
Mz_Init_Sprites_Dyn_Reload: ; loc_94994:  
        incbin  'data\mz\DynLevel\init_spr.bin' 
;--------------------------------------------------------
; Hidden Palace Zone Art
;--------------------------------------------------------    
Hidden_Palace_8x8_Tiles: ; loc_ABF2A: 
	incbin  'data\hpz\Tiles\hpz.bin'  
Hidden_Palace_16x16_Map: ; loc_AB5CA:
	incbin  'data\hpz\blocks\hpz.bin'    
Hidden_Palace_128x128_Map: ; loc_AF026:        
    incbin  'data\hpz\Chunks\hpz.bin'  
	even                       
Hpz_Init_Sprites_Dyn_Reload: ; loc_9B884: ;  Orbs
	incbin  'data\hpz\DynLevel\init_spr.bin'  
		
;--------------------------------------------------------
; Oil Ocean Zone Art
;--------------------------------------------------------	
Oil_Ocean_8x8_Tiles: ; loc_ABF2A: 
	incbin  'data\ooz\Tiles\ooz.bin'  
Oil_Ocean_16x16_Map: ; loc_AB5CA:
	incbin  'data\ooz\blocks\ooz.bin'    
Oil_Ocean_128x128_Map: ; loc_AF026:        
    incbin  'data\ooz\Chunks\ooz.bin'  
	even                  
OOz_Init_Sprites_Dyn_Reload: ; loc_A186A: ;  red ball, oil ...
	incbin  'data\ooz\DynLevel\init_spr.bin' 
	
;--------------------------------------------------------
; Dust Hill Zone Art
;--------------------------------------------------------	
Dust_Hill_8x8_Tiles: ; loc_ABF2A: 
	incbin  'data\dhz\Tiles\dhz.bin'  
Dust_Hill_16x16_Map: ; loc_AB5CA:
	incbin  'data\dhz\blocks\dhz.bin'    
Dust_Hill_128x128_Map: ; loc_AF026:        
    incbin  'data\dhz\Chunks\dhz.bin'  
	even  
	
;--------------------------------------------------------
; Casino Night Zone Art
;--------------------------------------------------------
Casino_Night_8x8_Tiles: ; loc_ABF2A: 
	incbin  'data\cnz\Tiles\cnz.bin'  
Casino_Night_16x16_Map: ; loc_AB5CA:
	incbin  'data\cnz\blocks\cnz.bin'    
Casino_Night_128x128_Map: ; loc_AF026:        
    incbin  'data\cnz\Chunks\cnz.bin'  
	even
Cnz_Cards: ; loc_AEF3C:           
	incbin  'data\cnz\DynLevel\cards.bin'		
	
;--------------------------------------------------------
; Chemical Plant Zone Art
;--------------------------------------------------------	
Chemical_Plant_8x8_Tiles: ; loc_ABF2A: 
	incbin  'data\cpz\Tiles\cpz.bin'  
Chemical_Plant_16x16_Map: ; loc_AB5CA:
	incbin  'data\cpz\blocks\cpz.bin'    
Chemical_Plant_128x128_Map: ; loc_AF026:        
    incbin  'data\cpz\Chunks\cpz.bin'  
	even
Cpz_Init_Sprites_Dyn_Reload: ; loc_B602E:  
        incbin  'data\cpz\objects\init_spr.bin' 

;--------------------------------------------------------
; Neo Green Hill Zone Art
;--------------------------------------------------------	
Neo_Green_Hill_8x8_Tiles: ; loc_ABF2A: 
	incbin  'data\nghz\Tiles\nghz.bin'  
Neo_Green_Hill_16x16_Map: ; loc_AB5CA:
	incbin  'data\nghz\blocks\nghz.bin'    
Neo_Green_Hill_128x128_Map: ; loc_AF026:        
    incbin  'data\nghz\Chunks\nghz.bin'  
	even   
Nghz_Init_Sprites_Dyn_Reload: ; loc_BF408:  Waterfalls
        incbin  'data\nghz\DynLevel\init_spr.bin'  		
loc_C2138: ; Leftover end of compressed Nghz 128x128 mappings...
    dc.w    $C00B, $F8C4, $C00B, $5200, $F8C0, $F80E, $F0, $0000  