loc_8B9C:
    moveq   #0, d0
    move.b  routine(A0), d0
    move.w  Obj17_Index(pc, d0), d1
    jmp     Obj17_Index(pc, d1)
;=============================================================================== 	
Obj17_Index:        
    dc.w    Obj17_Init-Obj17_Index
    dc.w    Obj17_Main-Obj17_Index
    dc.w    Obj17_Display-Obj17_Index
;=============================================================================== 	
Obj17_Init:
    addq.b  #2, routine(A0)
    move.l  #Obj17_Map, mappings(A0)
    move.w  #$4398, $2(A0)
    bsr     Adjust2PArtPointer     ; loc_DC30
    move.b  #4, $1(A0)
    move.b  #3, priority(A0)
    move.b  #8, width_pixels(A0)
    move.w  y_pos(A0), d2
    move.w  x_pos(A0), d3
    move.b  $0000(A0), d4
    lea     subtype(A0), a2
    moveq   #0, d1
    move.b  (a2), d1
    move.b  #0, (a2)+
    move.w  d1, d0
    lsr.w   #1, d0
    lsl.w   #4, d0
    sub.w   d0, d3
    subq.b  #2, d1
    bcs.s   Obj17_Main
    moveq   #0, d6
Obj17_MakeHelix:        
    bsr     JmpTo_SingleObjLoad2      ; loc_E788
    bne.s   Obj17_Main
    addq.b  #1, subtype(A0)
    move.w  a1, d5
    subi.w  #$B000, d5
    lsr.w   #6, d5
    andi.w  #$7F, d5
    move.b  d5, (a2)+
    move.b  #4, routine(a1)
    move.b  d4, $0000(a1)
    move.w  d2, y_pos(a1)
    move.w  d3, x_pos(a1)
    move.l  mappings(A0), mappings(a1)
    move.w  #$4398, $2(a1)
    bsr     ModifyA1SpriteAttr_2P   ; loc_DC4C
    move.b  #4, $1(a1)
    move.b  #3, priority(a1)
    move.b  #8, width_pixels(a1)
    move.b  d6, $3E(a1)
    addq.b  #1, d6
    andi.b  #7, d6
    addi.w  #$10, d3
    cmp.w   x_pos(A0), d3
    bne.s   loc_8C70
    move.b  d6, $3E(A0)
    addq.b  #1, d6
    andi.b  #7, d6
    addi.w  #$10, d3
    addq.b  #1, subtype(A0)
loc_8C70:
    dbra    d1, Obj17_MakeHelix
; ===========================================================================	
Obj17_Main:
    bsr     Obj17_RotateSpike
    move.w  x_pos(A0), d0
    andi.w  #$FF80, d0
    sub.w   (Camera_X_pos_coarse).w, d0
    cmpi.w  #$280, d0
    bhi     Obj17_DelAll
    bra     DisplaySprite       ; loc_D3C2
; ===========================================================================	
Obj17_DelAll:
    moveq   #0, d2
    lea     subtype(A0), a2
    move.b  (a2)+, d2
    subq.b  #2, d2
    bcs.s   BranchTo2_DeleteObject
Obj17_DelLoop:        
    moveq   #0, d0         
    move.b  (a2)+, d0
    lsl.w   #6, d0
    addi.l  #MainCharacter, d0
    move.l  d0, a1
    bsr     DeleteObject2
    dbra    d2, Obj17_DelLoop
; ===========================================================================	
BranchTo2_DeleteObject:
    bra     DeleteObject        ; loc_D3B4
; ===========================================================================	
Obj17_RotateSpike:
    move.b  ($FFFFFEC1).w, d0
    move.b  #0, collision_flags(A0)
    add.b   $3E(A0), d0
    andi.b  #7, d0
    move.b  d0, mapping_frame(A0)
    bne.s   loc_8CD4
    move.b  #$84, collision_flags(A0)
loc_8CD4:
    rts
; ===========================================================================	
Obj17_Display:
    bsr     Obj17_RotateSpike
    bra     DisplaySprite       ; loc_D3C2
; ===========================================================================	
Obj17_Map:
	incbin "mappings\Leftovers\Obj17log.bin"